﻿using System;
using System.Drawing;
using Grasshopper.GUI;
using Grasshopper.Kernel;
using Grasshopper.Kernel.Attributes;
namespace BitmapTooltip
{
    public class BitmapTooltipComponent : GH_Component
    {
        public int Index { get; private set; }
        public BitmapTooltipComponent()
          : base("BitmapTooltip", "Nickname", "Description",
              "Category", "Subcategory") {}
        protected override void RegisterInputParams(GH_InputParamManager pManager)
        {
            pManager.AddIntegerParameter("i", "i", "i", GH_ParamAccess.item, 0);
        }
        protected override void RegisterOutputParams(GH_OutputParamManager pManager) {}
        protected override void SolveInstance(IGH_DataAccess DA)
        {
            var i = 0;
            DA.GetData(0, ref i);
            i = Rhino.RhinoMath.Clamp(i, 0, 6);
            Index = i;

        }
        protected override Bitmap Icon => null;
        public override Guid ComponentGuid => new Guid("2f48bacb-0dac-4d2b-9a49-96e9790cc781");
        public override void CreateAttributes()
        {
            Attributes = new BitmapTooltipAttributes(this);
        }
    }
    public class BitmapTooltipAttributes : GH_ComponentAttributes
    {
        public BitmapTooltipAttributes(IGH_Component component) : base(component) { }
        public override void SetupTooltip(PointF point, GH_TooltipDisplayEventArgs e)
        {
            base.SetupTooltip(point,e);
            e.Description = "";
            e.Diagram = (Bitmap)Properties.Resources.ResourceManager.GetObject($"_{((BitmapTooltipComponent)Owner).Index}");
        }
    }
}